/*	$LAAS$ */
/*
 * Copyright (c) 2005 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _CANGYRO_H
#define _CANGYRO_H

#include "canGyroErrors.h"

typedef struct CAN_GYRO_STR {
	CAN_DEV *dev;			/* CAN device */
	int timeout;			/* timeout in micro-seconds */
	int recMsgId;			/* Id of received messages */
	pthread_mutex_t *mutex;
	double scale;
	BOOL connected;
	int value;
	int accel1;
	int accel2;
} CAN_GYRO_STR;

extern CAN_GYRO_STR *canGyroInit(CAN_DEV *);
extern void canGyroEnd(CAN_GYRO_STR *);
extern void canGyroRequestConnect(NEO_STR *);
extern void canGyroRequestAngle(NEO_STR *);
extern void canGyroZero(NEO_STR *);
extern void canGyroRequestAccel(NEO_STR *);
extern STATUS canGyroDecode(CAN_GYRO_STR *, CAN_MSG *);
extern double canGyroGetAngle(NEO_STR *);
extern void canGyroGetAccel(NEO_STR *, double *, double *);
extern void canGyroShow(NEO_STR *);

#endif
