/*	$LAAS$ */
/*
 * Copyright (c) 2005 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _CANUS_H
#define _CANUS_H

#include "canUSErrors.h"

/* The US Board can handle 16 sensors, but we have only 8 */
#define CAN_US_N_US 8		/* number of US sensors */
#define CAN_US_N_ANALOG 12	/* potential number of analog sensors */

typedef struct CAN_US_STR {
	CAN_DEV *dev;
	int recMsgId;
	pthread_mutex_t *mutex;
	BOOL connected;
	double scaleToMM;
	int dist[CAN_US_N_US];
	int analogIn[CAN_US_N_ANALOG];
} CAN_US_STR;

extern CAN_US_STR *canUSInit(CAN_DEV *);
extern void canUSEnd(CAN_US_STR *);
extern void canUSRequestConnect(NEO_STR *);
extern void canUSStart(NEO_STR *);
extern void canUSStop(NEO_STR *);
extern void canUSRequestDist(NEO_STR *);
extern void canUSRequestAnalog(NEO_STR *);
extern BOOL canUSDecode(CAN_US_STR *, CAN_MSG *);
extern STATUS canUSGetDist(NEO_STR *, int *);
extern STATUS canUSGetAnalog(NEO_STR *, int *);
extern void canUSShow(NEO_STR *);

#endif
