/*	$LAAS$ */
/*
 * Copyright (c) 2005 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _PSCAN_H
#define _PSCAN_H

#include <libpcan.h>
#include "pscanErrors.h"

typedef struct CAN_DEV {
	HANDLE handle;
	BOOL initialized;
} CAN_DEV;

/* CAN message structure */
typedef struct CAN_MSG {
	unsigned int id;
	unsigned char type;
	unsigned char len;
	unsigned char data[8];
} CAN_MSG;

extern CAN_DEV *pscanInit(char *);
extern void pscanEnd(CAN_DEV *);
extern int pscanTransmitMsg(CAN_DEV *, CAN_MSG *);
extern STATUS pscanReceiveMsg(CAN_DEV *, CAN_MSG *);
extern STATUS pscanReceiveMsgWait(CAN_DEV *, CAN_MSG *, int);
extern void canMsgSet(CAN_MSG *, int, int, int, int, int, int, int, int, int);
extern int canMsgGetInt(CAN_MSG *, int);
extern int canGetStatus(CAN_MSG *);
extern int canGetCmd(CAN_MSG *);
extern void canMsgShow(CAN_MSG *);


#endif
