/*	$LAAS$ */
/*
 * Copyright (c) 2005 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _DRIVEPARAM_H
#define _DRIVEPARAM_H

#define DRIVE_PARAM_ENC_INCR_PER_REV_MOT 8000
#define DRIVE_PARAM_GEAR_RATIO 37
#define DRIVE_PARAM_SIGN -1.0
#define DRIVE_PARAMS_VEL_MAX_ENC_INCR_S 450000

/* Misc drive parameters */
typedef struct CAN_DRIVE_PARAMS {
	int driveIdent;
	int encIncrPerRevMot;
	double gearRatio;
	int sign;
	double velMaxEncIncrS;
	double posGearRadToPosMotIncr;
} CAN_DRIVE_PARAMS;

#define driveParamGetDriveIdent(p) ((p)->driveIdent)
#define driveParamGetSign(p) ((p)->sign)
#define driveParamGetVelMax(p) ((p)->velMaxEncIncrS)

extern void driveParamInit(CAN_DRIVE_PARAMS *, int);
extern void driveParamPosVelRadToIncr(CAN_DRIVE_PARAMS *, double, double, 
    int *, int *); 
extern int driveParamPosGearRadToPosMotIncr(CAN_DRIVE_PARAMS *, double);
extern double driveParamPosMotIncrToPosGearRad(CAN_DRIVE_PARAMS *, int);
extern int driveParamVelGearRadSToVelMotIncrPeriod(CAN_DRIVE_PARAMS *, double);
extern double driveParamVelMotIncrPeriodToVelGearRadS(CAN_DRIVE_PARAMS *, int);

#endif
